module ThreadUtil (forkChild, waitForChildren) where

import Control.Concurrent
import Control.Exception (finally)

forkChild :: MVar [MVar ()] -> IO () -> IO ThreadId
forkChild children io = do
  mvar <- newEmptyMVar
  children' <- takeMVar children
  putMVar children (mvar : children')
  forkIO (io `finally` putMVar mvar ())

waitForChildren :: MVar [MVar ()] -> IO ()
waitForChildren children = do
  cs <- takeMVar children
  case cs of
    [] -> return ()
    (c : cs) -> do
      putMVar children cs
      takeMVar c
      waitForChildren children
